︠cc7ed503-748f-481a-8fb5-cb068ec168e5︠
%md

# Chankillo Solar Observatory Worksheet \#2

Background: 

We will need the elevations of the observation points and the hill over which
sunrise will be observed.

## Get Elevation of Observation Points and Towers

Use NASA Shuttle Radar Topographic Mission (SRTM) online data to
obtain approximate elevation for the two observation points and the hill on which
the 13 towers rest.

Use longitude and latitude obtained by manually selecting points in Google Earth.

## bounding rectangle of the ruins:

- lat of northmost tower: -9.560356965861502
- lat of southmost tower: -9.562037172307594
- lon of west observation point: -78.2296179913435
- lon of east observation point: -78.22573325657659

## SRTMv4 data for 5-degree rectangle containing the ruins

### Download the SRTM file

Files are here: http://www.cgiar-csi.org/data/srtm-90m-digital-elevation-database-v4-1

Enter extremes of the bounding rectangle using the download GUI here http://srtm.csi.cgiar.org/SELECTION/inputCoord.asp

<img src="cgiar-select.png" width="80%">

Search returns one file. Download that.

<img src="cgiar-select2.png" width="80%">


### File format

Based on info at [ESRI ASCII Raster format](http://resources.esri.com/help/9.3/arcgisdesktop/com/gp_toolref/spatial_analyst_tools/esri_ascii_raster_format.htm),

Row 1 of the data is at the top of the raster, row 2 is just under row 1, and so on.

### File header
```
$ head -6 srtm_21_14.asc 
ncols         6001
nrows         6001
xllcorner     -80.000416424533
yllcorner     -10.000416206603
cellsize      0.00083333333333333
NODATA_value  -9999

```

### Data values represent elevation in meters

http://wiki.openstreetmap.org/wiki/SRTM

> Each file is a series of 16-bit integers giving the height of each cell in meters arranged from west to east and then north to south




︡6f1ecae9-c941-484b-88aa-b44494f02237︡{"done":true,"md":"\n# Chankillo Solar Observatory Worksheet \\#2\n\n## Get Elevation of Observation Points and Towers\n\nUse NASA Shuttle Radar Topographic Mission (SRTM) online data to\nobtain approximate elevation for the two observation points and the hill on which\nthe 13 towers rest.\n\nUse longitude and latitude obtained by manually selecting points in Google Earth.\n\n## bounding rectangle of the ruins:\n\n- lat of northmost tower: -9.560356965861502\n- lat of southmost tower: -9.562037172307594\n- lon of west observation point: -78.2296179913435\n- lon of east observation point: -78.22573325657659\n\n## SRTMv4 data for 5-degree rectangle containing the ruins\n\n### Download the SRTM file\n\nFiles are here: http://www.cgiar-csi.org/data/srtm-90m-digital-elevation-database-v4-1\n\nEnter extremes of the bounding rectangle using the download GUI here http://srtm.csi.cgiar.org/SELECTION/inputCoord.asp\n\n<img src=\"cgiar-select.png\" width=\"80%\">\n\nSearch returns one file. Download that.\n\n<img src=\"cgiar-select2.png\" width=\"80%\">\n\n\n### File format\n\nBased on info at [ESRI ASCII Raster format](http://resources.esri.com/help/9.3/arcgisdesktop/com/gp_toolref/spatial_analyst_tools/esri_ascii_raster_format.htm),\n\nRow 1 of the data is at the top of the raster, row 2 is just under row 1, and so on.\n\n### File header\n```\n$ head -6 srtm_21_14.asc \nncols         6001\nnrows         6001\nxllcorner     -80.000416424533\nyllcorner     -10.000416206603\ncellsize      0.00083333333333333\nNODATA_value  -9999\n\n```\n\n### Data values represent elevation in meters\n\nhttp://wiki.openstreetmap.org/wiki/SRTM\n\n> Each file is a series of 16-bit integers giving the height of each cell in meters arranged from west to east and then north to south"}
︠3a1c8482-d251-4124-9a00-78825c39040fs︠
# download files cover 5 degree range on both axes
# and have elevation for 6001 x 6001 grid
xllcorner = -80.000416424533
yllcorner = -10.000416206603
cellsize = 5.0/6000
︡f6517346-68ee-4123-9085-f1e56cf364ff︡{"done":true}︡
︠c8b99b61-0759-4ef0-be75-1f854fa453d6s︠
# use x for ruins longitude, y for ruins latitude
xmax = -78.22573325657659
xmin = -78.2296179913435

ymax = -9.560356965861502
ymin = -9.562037172307594
︡b83fb587-58e6-43f6-b65f-53399c416684︡{"done":true}︡
︠4ad308dd-5378-4006-bb31-ecec1cc146a3s︠
# given longitude and latitude inside the SRTM rectangle,
# return 1-based row and column for that point

def get_row_and_col(pt):
    longitude, latitude = pt
    ncols = 6001
    nrows = 6001

    xllcorner = -80.000416424533
    yllcorner = -10.000416206603
    cellsize = 5.0/6000

    row_offset = (latitude - yllcorner) / cellsize
    row = nrows - int(row_offset) + 1
    
    col_offset = (longitude - xllcorner) / cellsize
    col = int(col_offset) + 1
    return row, col
︡4cdd4378-1a75-4e00-8bc6-40f2e47c23e1︡{"done":true}︡
︠dfe68c0f-4ca5-42cf-9540-7a869ea8d234︠
# northmost tower
ptower1 = (-78.22748775951226,-9.560356965861502)
get_row_and_col(ptower1)
# allowing for 6-line header, we want line number 5480 from the SRTM file
# line 5480, col 2128 -> 204
︡1d1aafdc-5195-4344-bf54-83e434c64c30︡{"stdout":"(5474, 2128)\n"}︡{"done":true}︡
︠6f34c31e-2abe-4085-880b-91c9efb09324︠
# southmost tower
ptower13 = (-78.22760136797875,-9.562037172307594)
get_row_and_col(ptower13)
# line 5482, col 2128 -> 209
︡3b224125-ffa6-422f-8336-d923942f1fd0︡{"stdout":"(5476, 2128)\n"}︡{"done":true}︡
︠f79a8736-d026-476e-ab10-ef8f8e67d96b︠
# west observation point
pwestop = (-78.2296179913435,-9.561116373529829)
get_row_and_col(pwestop)
# line 5481, col 2125 -> 175
︡513c2eec-e83d-4ead-8d93-e05e0415b11e︡{"stdout":"(5475, 2125)\n"}︡{"done":true}︡
︠109bc3e0-f1c3-4895-b36d-54f54cce75ee︠
# east observation point
peastop = (-78.22573325657659,-9.561143170696472)
get_row_and_col(peastop)
# line 5481, col 2130 -> 175
︡cdb1a10d-1c2d-47b4-8064-9f7b92ca76fc︡{"stdout":"(5475, 2130)\n"}︡{"done":true}︡
︠6b5c382c-c0f8-428e-bc86-918807acb7d4︠
%sh
# print the elevations in meters for the bounding rectangle by extracting info
# from the SRTM file
# rows of matrix top to bottom represent north to south
# columns of matrix left to right represent west to east
unzip -p srtm_21_14.zip srtm_21_14.asc |
  sed -n 5480,5482p |
  cut -d' ' -f2125-2130 |
  tee ruins_elevations.txt
︡c39351d6-9994-4ab1-b133-5b2bf19a5c82︡{"stdout":"174 176 179 204 184 167\n"}︡{"stdout":"175 179 187 210 192 175\n"}︡{"stdout":"175 174 189 209 187 174\n"}︡{"done":true}︡
︠8551191c-6c95-4bfe-9882-387b9374ac59s︠
mean([204, 210, 209]).n()
︡555d3db4-c603-425c-abf8-81035cf0eeb7︡{"stdout":"207.666666666667\n"}︡{"done":true}︡
︠3e4e6547-f080-42b7-8f6f-abde147e3b45i︠
%md

Approximate elevations in m above sea level:

- W and E observation points: 175

- Crest of hill (average, running North-South) with 13 towers: 208
︡19dc81b5-a096-4bbb-a825-450046c413a8︡{"done":true,"md":"\nApproximate elevations in m above sea level:\n\n- W and E observation points: 175\n\n- Crest of hill (average, running North-South) with 13 towers: 208"}









